<html>
<head>
<title>OgreRenderTarget.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreRenderTarget.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreRenderTarget_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __RenderTarget_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __RenderTarget_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreString_8h.html">OgreString.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreTextureManager_8h.html">OgreTextureManager.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreViewport_8h.html">OgreViewport.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreTimer_8h.html">OgreTimer.h</a>&quot;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="comment">/* Define the number of priority groups for the render system&#39;s render targets. */</span>
<a name="l00039"></a>00039 <span class="preprocessor">#ifndef OGRE_NUM_RENDERTARGET_GROUPS</span>
<a name="l00040"></a>00040 <span class="preprocessor"></span><span class="preprocessor">    #define OGRE_NUM_RENDERTARGET_GROUPS 10</span>
<a name="l00041"></a>00041 <span class="preprocessor"></span><span class="preprocessor">    #define OGRE_DEFAULT_RT_GROUP 4</span>
<a name="l00042"></a>00042 <span class="preprocessor"></span><span class="preprocessor">    #define OGRE_REND_TO_TEX_RT_GROUP 2</span>
<a name="l00043"></a>00043 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00044"></a>00044 <span class="preprocessor"></span>
<a name="l00045"></a>00045 <span class="keyword">namespace </span>Ogre {
<a name="l00046"></a>00046 
<a name="l00064"></a><a class="code" href="classOgre_1_1RenderTarget.html">00064</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1RenderTarget.html" title="A &#39;canvas&#39; which can receive the results of a rendering operation.">RenderTarget</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">RenderSysAlloc</a>
<a name="l00065"></a>00065     {
<a name="l00066"></a>00066     <span class="keyword">public</span>:
<a name="l00067"></a><a class="code" href="classOgre_1_1RenderTarget.html#a15f59cd1b4a2b2e65fcee349d78ae490">00067</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1RenderTarget.html#a15f59cd1b4a2b2e65fcee349d78ae490">StatFlags</a>
<a name="l00068"></a>00068         {
<a name="l00069"></a><a class="code" href="classOgre_1_1RenderTarget.html#a15f59cd1b4a2b2e65fcee349d78ae490a6df94556ae07dfa0384808dca8dedb64">00069</a>             SF_NONE           = 0,
<a name="l00070"></a><a class="code" href="classOgre_1_1RenderTarget.html#a15f59cd1b4a2b2e65fcee349d78ae490a1f0cd329c7ff6d5d81b2162c65d04afa">00070</a>             SF_FPS            = 1,
<a name="l00071"></a><a class="code" href="classOgre_1_1RenderTarget.html#a15f59cd1b4a2b2e65fcee349d78ae490a5ee29312d754f2244987dc0d1f5894e8">00071</a>             SF_AVG_FPS        = 2,
<a name="l00072"></a><a class="code" href="classOgre_1_1RenderTarget.html#a15f59cd1b4a2b2e65fcee349d78ae490ac08101cb24d35c29eb7064886081e386">00072</a>             SF_BEST_FPS       = 4,
<a name="l00073"></a><a class="code" href="classOgre_1_1RenderTarget.html#a15f59cd1b4a2b2e65fcee349d78ae490aba6283bc81ca4e5e6cd2b85497a2cc2f">00073</a>             SF_WORST_FPS      = 8,
<a name="l00074"></a><a class="code" href="classOgre_1_1RenderTarget.html#a15f59cd1b4a2b2e65fcee349d78ae490a19ef0adeaa177d49fc4ca4c9b87adec1">00074</a>             SF_TRIANGLE_COUNT = 16,
<a name="l00075"></a><a class="code" href="classOgre_1_1RenderTarget.html#a15f59cd1b4a2b2e65fcee349d78ae490a18416c60c9b82d928db766bef672ecea">00075</a>             SF_ALL            = 0xFFFF
<a name="l00076"></a>00076         };
<a name="l00077"></a>00077 
<a name="l00078"></a><a class="code" href="structOgre_1_1RenderTarget_1_1FrameStats.html">00078</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1RenderTarget_1_1FrameStats.html">FrameStats</a>
<a name="l00079"></a>00079         {
<a name="l00080"></a><a class="code" href="structOgre_1_1RenderTarget_1_1FrameStats.html#a12556de54d8ea0ca7ccf064a07d25389">00080</a>             <span class="keywordtype">float</span> <a class="code" href="structOgre_1_1RenderTarget_1_1FrameStats.html#a12556de54d8ea0ca7ccf064a07d25389">lastFPS</a>;
<a name="l00081"></a><a class="code" href="structOgre_1_1RenderTarget_1_1FrameStats.html#a4e2453ac395f96a11a966f18590610e0">00081</a>             <span class="keywordtype">float</span> <a class="code" href="structOgre_1_1RenderTarget_1_1FrameStats.html#a4e2453ac395f96a11a966f18590610e0">avgFPS</a>;
<a name="l00082"></a><a class="code" href="structOgre_1_1RenderTarget_1_1FrameStats.html#ab07828877ca7c352d1a8b1afaab1df08">00082</a>             <span class="keywordtype">float</span> <a class="code" href="structOgre_1_1RenderTarget_1_1FrameStats.html#ab07828877ca7c352d1a8b1afaab1df08">bestFPS</a>;
<a name="l00083"></a><a class="code" href="structOgre_1_1RenderTarget_1_1FrameStats.html#a49f1dd55396299921e69e1d7ed66c0fc">00083</a>             <span class="keywordtype">float</span> <a class="code" href="structOgre_1_1RenderTarget_1_1FrameStats.html#a49f1dd55396299921e69e1d7ed66c0fc">worstFPS</a>;
<a name="l00084"></a><a class="code" href="structOgre_1_1RenderTarget_1_1FrameStats.html#a720bee3828b5c2d2419e7afbeed0191e">00084</a>             <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="structOgre_1_1RenderTarget_1_1FrameStats.html#a720bee3828b5c2d2419e7afbeed0191e">bestFrameTime</a>;
<a name="l00085"></a><a class="code" href="structOgre_1_1RenderTarget_1_1FrameStats.html#a7536670fa555a4f05c52ccdacc9c2194">00085</a>             <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="structOgre_1_1RenderTarget_1_1FrameStats.html#a7536670fa555a4f05c52ccdacc9c2194">worstFrameTime</a>;
<a name="l00086"></a><a class="code" href="structOgre_1_1RenderTarget_1_1FrameStats.html#ab1bf6f713ee6774a371fdf74f2ffaf44">00086</a>             <span class="keywordtype">size_t</span> <a class="code" href="structOgre_1_1RenderTarget_1_1FrameStats.html#ab1bf6f713ee6774a371fdf74f2ffaf44">triangleCount</a>;
<a name="l00087"></a><a class="code" href="structOgre_1_1RenderTarget_1_1FrameStats.html#a6b4e063f6df89d63021022eb8f43d91c">00087</a>             <span class="keywordtype">size_t</span> <a class="code" href="structOgre_1_1RenderTarget_1_1FrameStats.html#a6b4e063f6df89d63021022eb8f43d91c">batchCount</a>;
<a name="l00088"></a>00088         };
<a name="l00089"></a>00089 
<a name="l00090"></a><a class="code" href="classOgre_1_1RenderTarget.html#a4b42772d32712767391c749f4745397a">00090</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1RenderTarget.html#a4b42772d32712767391c749f4745397a">FrameBuffer</a>
<a name="l00091"></a>00091         {
<a name="l00092"></a><a class="code" href="classOgre_1_1RenderTarget.html#a4b42772d32712767391c749f4745397aaa9d982cf6f703ba525577fdd487ae5e8">00092</a>             <a class="code" href="classOgre_1_1RenderTarget.html#a4b42772d32712767391c749f4745397aaa9d982cf6f703ba525577fdd487ae5e8">FB_FRONT</a>,
<a name="l00093"></a><a class="code" href="classOgre_1_1RenderTarget.html#a4b42772d32712767391c749f4745397aa632020df02d4d37ee90ff4ff0a5b7b86">00093</a>             <a class="code" href="classOgre_1_1RenderTarget.html#a4b42772d32712767391c749f4745397aa632020df02d4d37ee90ff4ff0a5b7b86">FB_BACK</a>,
<a name="l00094"></a><a class="code" href="classOgre_1_1RenderTarget.html#a4b42772d32712767391c749f4745397aa7c2856681602b85c62439a67a247c322">00094</a>             FB_AUTO
<a name="l00095"></a>00095         };
<a name="l00096"></a>00096 
<a name="l00097"></a>00097         <a class="code" href="classOgre_1_1RenderTarget.html" title="A &#39;canvas&#39; which can receive the results of a rendering operation.">RenderTarget</a>();
<a name="l00098"></a>00098         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1RenderTarget.html" title="A &#39;canvas&#39; which can receive the results of a rendering operation.">RenderTarget</a>();
<a name="l00099"></a>00099 
<a name="l00101"></a>00101         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getName(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00102"></a>00102 
<a name="l00104"></a>00104         <span class="keyword">virtual</span> <span class="keywordtype">void</span> getMetrics(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; width, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; height, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; colourDepth);
<a name="l00105"></a>00105 
<a name="l00106"></a>00106         <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> getWidth(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00107"></a>00107         <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> getHeight(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00108"></a>00108         <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> getColourDepth(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00109"></a>00109 
<a name="l00117"></a>00117         <span class="keywordtype">void</span> setDepthBufferPool( <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> poolId );
<a name="l00118"></a>00118 
<a name="l00119"></a>00119         <span class="comment">//Returns the pool ID this RenderTarget should query from. @see DepthBuffer</span>
<a name="l00120"></a>00120         <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> getDepthBufferPool() <span class="keyword">const</span>;
<a name="l00121"></a>00121 
<a name="l00122"></a>00122         <a class="code" href="classOgre_1_1DepthBuffer.html" title="An abstract class that contains a depth/stencil buffer.">DepthBuffer</a>* getDepthBuffer() <span class="keyword">const</span>;
<a name="l00123"></a>00123 
<a name="l00124"></a>00124         <span class="comment">//Returns false if couldn&#39;t attach</span>
<a name="l00125"></a>00125         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> attachDepthBuffer( <a class="code" href="classOgre_1_1DepthBuffer.html" title="An abstract class that contains a depth/stencil buffer.">DepthBuffer</a> *depthBuffer );
<a name="l00126"></a>00126 
<a name="l00127"></a>00127         <span class="keyword">virtual</span> <span class="keywordtype">void</span> detachDepthBuffer();
<a name="l00128"></a>00128 
<a name="l00133"></a>00133         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _detachDepthBuffer();
<a name="l00134"></a>00134 
<a name="l00157"></a>00157         <span class="keyword">virtual</span> <span class="keywordtype">void</span> update(<span class="keywordtype">bool</span> swapBuffers = <span class="keyword">true</span>);
<a name="l00178"></a><a class="code" href="classOgre_1_1RenderTarget.html#a09e6243be6bd93a64e9b20c74e3d11e1">00178</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> swapBuffers(<span class="keywordtype">bool</span> waitForVSync = <span class="keyword">true</span>)
<a name="l00179"></a>00179         { (void)waitForVSync; }
<a name="l00180"></a>00180 
<a name="l00204"></a>00204         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a>* addViewport(<a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam, <span class="keywordtype">int</span> ZOrder = 0, <span class="keywordtype">float</span> left = 0.0f, <span class="keywordtype">float</span> top = 0.0f ,
<a name="l00205"></a>00205             <span class="keywordtype">float</span> width = 1.0f, <span class="keywordtype">float</span> height = 1.0f);
<a name="l00206"></a>00206 
<a name="l00208"></a>00208         <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> getNumViewports(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00209"></a>00209 
<a name="l00211"></a>00211         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a>* getViewport(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index);
<a name="l00212"></a>00212 
<a name="l00216"></a>00216         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a>* getViewportByZOrder(<span class="keywordtype">int</span> ZOrder);
<a name="l00217"></a>00217 
<a name="l00219"></a>00219         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> hasViewportWithZOrder(<span class="keywordtype">int</span> ZOrder);
<a name="l00220"></a>00220 
<a name="l00223"></a>00223         <span class="keyword">virtual</span> <span class="keywordtype">void</span> removeViewport(<span class="keywordtype">int</span> ZOrder);
<a name="l00224"></a>00224 
<a name="l00227"></a>00227         <span class="keyword">virtual</span> <span class="keywordtype">void</span> removeAllViewports(<span class="keywordtype">void</span>);
<a name="l00228"></a>00228 
<a name="l00247"></a>00247         <span class="keyword">virtual</span> <span class="keywordtype">void</span> getStatistics(<span class="keywordtype">float</span>&amp; lastFPS, <span class="keywordtype">float</span>&amp; avgFPS,
<a name="l00248"></a>00248             <span class="keywordtype">float</span>&amp; bestFPS, <span class="keywordtype">float</span>&amp; worstFPS) <span class="keyword">const</span>;  <span class="comment">// Access to stats</span>
<a name="l00249"></a>00249 
<a name="l00250"></a>00250         <span class="keyword">virtual</span> <span class="keyword">const</span> FrameStats&amp; getStatistics(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00251"></a>00251 
<a name="l00254"></a>00254         <span class="keyword">virtual</span> <span class="keywordtype">float</span> getLastFPS() <span class="keyword">const</span>;
<a name="l00255"></a>00255 
<a name="l00258"></a>00258         <span class="keyword">virtual</span> <span class="keywordtype">float</span> getAverageFPS() <span class="keyword">const</span>;
<a name="l00259"></a>00259 
<a name="l00262"></a>00262         <span class="keyword">virtual</span> <span class="keywordtype">float</span> getBestFPS() <span class="keyword">const</span>;
<a name="l00263"></a>00263 
<a name="l00266"></a>00266         <span class="keyword">virtual</span> <span class="keywordtype">float</span> getWorstFPS() <span class="keyword">const</span>;
<a name="l00267"></a>00267 
<a name="l00270"></a>00270         <span class="keyword">virtual</span> <span class="keywordtype">float</span> getBestFrameTime() <span class="keyword">const</span>;
<a name="l00271"></a>00271 
<a name="l00274"></a>00274         <span class="keyword">virtual</span> <span class="keywordtype">float</span> getWorstFrameTime() <span class="keyword">const</span>;
<a name="l00275"></a>00275 
<a name="l00278"></a>00278         <span class="keyword">virtual</span> <span class="keywordtype">void</span> resetStatistics(<span class="keywordtype">void</span>);
<a name="l00279"></a>00279 
<a name="l00289"></a>00289         <span class="keyword">virtual</span> <span class="keywordtype">void</span> getCustomAttribute(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keywordtype">void</span>* pData);
<a name="l00290"></a>00290 
<a name="l00299"></a>00299         <span class="keyword">virtual</span> <span class="keywordtype">void</span> addListener(<a class="code" href="classOgre_1_1RenderTargetListener.html" title="A interface class defining a listener which can be used to receive notifications of RenderTarget even...">RenderTargetListener</a>* listener);
<a name="l00301"></a>00301         <span class="keyword">virtual</span> <span class="keywordtype">void</span> removeListener(<a class="code" href="classOgre_1_1RenderTargetListener.html" title="A interface class defining a listener which can be used to receive notifications of RenderTarget even...">RenderTargetListener</a>* listener);
<a name="l00303"></a>00303         <span class="keyword">virtual</span> <span class="keywordtype">void</span> removeAllListeners(<span class="keywordtype">void</span>);
<a name="l00304"></a>00304 
<a name="l00312"></a><a class="code" href="classOgre_1_1RenderTarget.html#a03ae803c4754c6008fb5b898fb8090b8">00312</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1RenderTarget.html#a03ae803c4754c6008fb5b898fb8090b8" title="Sets the priority of this render target in relation to the others.">setPriority</a>( <a class="code" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4" title="In order to avoid finger-aches :)">uchar</a> priority ) { mPriority = priority; }
<a name="l00314"></a><a class="code" href="classOgre_1_1RenderTarget.html#abb30435cde04c7c81a93b5f94b13e27e">00314</a>         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4" title="In order to avoid finger-aches :)">uchar</a> <a class="code" href="classOgre_1_1RenderTarget.html#abb30435cde04c7c81a93b5f94b13e27e" title="Gets the priority of a render target.">getPriority</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mPriority; }
<a name="l00315"></a>00315 
<a name="l00318"></a>00318         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isActive() <span class="keyword">const</span>;
<a name="l00319"></a>00319 
<a name="l00322"></a>00322         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setActive( <span class="keywordtype">bool</span> state );
<a name="l00323"></a>00323 
<a name="l00335"></a>00335         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setAutoUpdated(<span class="keywordtype">bool</span> autoupdate);
<a name="l00339"></a>00339         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isAutoUpdated(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00340"></a>00340 
<a name="l00346"></a>00346         <span class="keyword">virtual</span> <span class="keywordtype">void</span> copyContentsToMemory(<span class="keyword">const</span> <a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">PixelBox</a> &amp;dst, FrameBuffer buffer = FB_AUTO) = 0;
<a name="l00347"></a>00347 
<a name="l00351"></a><a class="code" href="classOgre_1_1RenderTarget.html#a8fe5655c73a3d7a31343c1d55c7f8063">00351</a>         <span class="keyword">virtual</span> <a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> <a class="code" href="classOgre_1_1RenderTarget.html#a8fe5655c73a3d7a31343c1d55c7f8063" title="Suggests a pixel format to use for extracting the data in this target, when calling copyContentsToMem...">suggestPixelFormat</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="group__Image.html#gga7e0353e7d36d4c2e8468641b7303d39cae0afb06af1cb73f624e66540c64bb2cb" title="4 byte pixel format, 1 byte for red, 1 byte for green, 1 byte for blue, and one byte for alpha...">PF_BYTE_RGBA</a>; }
<a name="l00352"></a>00352         
<a name="l00354"></a>00354         <span class="keywordtype">void</span> writeContentsToFile(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; filename);
<a name="l00355"></a>00355 
<a name="l00358"></a>00358         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> writeContentsToTimestampedFile(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; filenamePrefix, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; filenameSuffix);
<a name="l00359"></a>00359 
<a name="l00360"></a>00360         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> requiresTextureFlipping() <span class="keyword">const</span> = 0;
<a name="l00361"></a>00361 
<a name="l00363"></a>00363         <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> getTriangleCount(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00365"></a>00365         <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> getBatchCount(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00369"></a>00369         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _notifyCameraRemoved(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam);
<a name="l00370"></a>00370 
<a name="l00377"></a>00377         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isPrimary(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00378"></a>00378 
<a name="l00386"></a><a class="code" href="classOgre_1_1RenderTarget.html#ae08fe8769b24dd6ab55eaf25c53721b8">00386</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1RenderTarget.html#ae08fe8769b24dd6ab55eaf25c53721b8" title="Indicates whether on rendering, linear colour space is converted to sRGB gamma colour space...">isHardwareGammaEnabled</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mHwGamma; }
<a name="l00387"></a>00387 
<a name="l00390"></a><a class="code" href="classOgre_1_1RenderTarget.html#af6517fc9bc27d14300afb70aceabb737">00390</a>         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> <a class="code" href="classOgre_1_1RenderTarget.html#af6517fc9bc27d14300afb70aceabb737" title="Indicates whether multisampling is performed on rendering and at what level.">getFSAA</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mFSAA; }
<a name="l00391"></a>00391 
<a name="l00394"></a><a class="code" href="classOgre_1_1RenderTarget.html#a582f7e9659ce618d1578e24cd5231546">00394</a>         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1RenderTarget.html#a582f7e9659ce618d1578e24cd5231546" title="Gets the FSAA hint (.">getFSAAHint</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mFSAAHint; }
<a name="l00395"></a>00395 
<a name="l00399"></a><a class="code" href="classOgre_1_1RenderTarget_1_1Impl.html">00399</a>         <span class="keyword">class </span><a class="code" href="classOgre_1_1RenderTarget_1_1Impl.html" title="RenderSystem specific interface for a RenderTarget; this should be subclassed by RenderSystems.">Impl</a>
<a name="l00400"></a>00400         {
<a name="l00401"></a>00401         <span class="keyword">protected</span>:
<a name="l00402"></a><a class="code" href="classOgre_1_1RenderTarget_1_1Impl.html#ab336a07f12030cd9e4efe9330334542e">00402</a>             <a class="code" href="classOgre_1_1RenderTarget_1_1Impl.html#ab336a07f12030cd9e4efe9330334542e">~Impl</a>() { }
<a name="l00403"></a>00403         };
<a name="l00409"></a>00409         <span class="keyword">virtual</span> Impl *_getImpl();
<a name="l00410"></a>00410 
<a name="l00434"></a>00434         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _beginUpdate();
<a name="l00435"></a>00435 
<a name="l00445"></a>00445         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _updateViewport(<span class="keywordtype">int</span> zorder, <span class="keywordtype">bool</span> updateStatistics = <span class="keyword">true</span>);
<a name="l00446"></a>00446 
<a name="l00455"></a>00455         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _updateViewport(<a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a>* viewport, <span class="keywordtype">bool</span> updateStatistics = <span class="keyword">true</span>);
<a name="l00456"></a>00456 
<a name="l00465"></a>00465         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _updateAutoUpdatedViewports(<span class="keywordtype">bool</span> updateStatistics = <span class="keyword">true</span>);
<a name="l00466"></a>00466         
<a name="l00473"></a>00473         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _endUpdate();
<a name="l00474"></a>00474 
<a name="l00475"></a>00475     <span class="keyword">protected</span>:
<a name="l00477"></a><a class="code" href="classOgre_1_1RenderTarget.html#af2cc3c6d5a845d8c7eb3b6cdc4270639">00477</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1RenderTarget.html#af2cc3c6d5a845d8c7eb3b6cdc4270639" title="The name of this target.">mName</a>;
<a name="l00479"></a><a class="code" href="classOgre_1_1RenderTarget.html#a58b3cee9ce06c665d120234f425a188f">00479</a>         <a class="code" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4" title="In order to avoid finger-aches :)">uchar</a> <a class="code" href="classOgre_1_1RenderTarget.html#a58b3cee9ce06c665d120234f425a188f" title="The priority of the render target.">mPriority</a>;
<a name="l00480"></a>00480 
<a name="l00481"></a><a class="code" href="classOgre_1_1RenderTarget.html#ab3f6f293e5347db866b70ab7dfcf6018">00481</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1RenderTarget.html#ab3f6f293e5347db866b70ab7dfcf6018">mWidth</a>;
<a name="l00482"></a><a class="code" href="classOgre_1_1RenderTarget.html#a02bf10a710dcdf3b5e384f8c7d2903af">00482</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1RenderTarget.html#a02bf10a710dcdf3b5e384f8c7d2903af">mHeight</a>;
<a name="l00483"></a><a class="code" href="classOgre_1_1RenderTarget.html#a79386cb8836a76d429466c0910374aaa">00483</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1RenderTarget.html#a79386cb8836a76d429466c0910374aaa">mColourDepth</a>;
<a name="l00484"></a><a class="code" href="classOgre_1_1RenderTarget.html#acdddc6c24243a765311228402496d5dd">00484</a>         <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a>       <a class="code" href="classOgre_1_1RenderTarget.html#acdddc6c24243a765311228402496d5dd">mDepthBufferPoolId</a>;
<a name="l00485"></a><a class="code" href="classOgre_1_1RenderTarget.html#ac2eb8a47d549be98a68455a159091429">00485</a>         <a class="code" href="classOgre_1_1DepthBuffer.html" title="An abstract class that contains a depth/stencil buffer.">DepthBuffer</a> *<a class="code" href="classOgre_1_1RenderTarget.html#ac2eb8a47d549be98a68455a159091429">mDepthBuffer</a>;
<a name="l00486"></a>00486 
<a name="l00487"></a>00487         <span class="comment">// Stats</span>
<a name="l00488"></a><a class="code" href="classOgre_1_1RenderTarget.html#aec8db4bff24a18224ea22ae0dcd2b0b9">00488</a>         <a class="code" href="structOgre_1_1RenderTarget_1_1FrameStats.html">FrameStats</a> <a class="code" href="classOgre_1_1RenderTarget.html#aec8db4bff24a18224ea22ae0dcd2b0b9">mStats</a>;
<a name="l00489"></a>00489         
<a name="l00490"></a><a class="code" href="classOgre_1_1RenderTarget.html#a9edbadbd9ebd933c51dd6d63303ffeaa">00490</a>         <a class="code" href="classOgre_1_1Timer.html" title="Timer class.">Timer</a>* <a class="code" href="classOgre_1_1RenderTarget.html#a9edbadbd9ebd933c51dd6d63303ffeaa">mTimer</a> ;
<a name="l00491"></a><a class="code" href="classOgre_1_1RenderTarget.html#ae2c3190a38dd1febbacaa7d26a99b847">00491</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="classOgre_1_1RenderTarget.html#ae2c3190a38dd1febbacaa7d26a99b847">mLastSecond</a>;
<a name="l00492"></a><a class="code" href="classOgre_1_1RenderTarget.html#acb4383973de9408b1f855e15357332cb">00492</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="classOgre_1_1RenderTarget.html#acb4383973de9408b1f855e15357332cb">mLastTime</a>;
<a name="l00493"></a><a class="code" href="classOgre_1_1RenderTarget.html#a7c01f88029925f275dc8a49800dd3998">00493</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1RenderTarget.html#a7c01f88029925f275dc8a49800dd3998">mFrameCount</a>;
<a name="l00494"></a>00494 
<a name="l00495"></a><a class="code" href="classOgre_1_1RenderTarget.html#ae2a74c5e2b8d58720fb520401a3f8c5f">00495</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1RenderTarget.html#ae2a74c5e2b8d58720fb520401a3f8c5f">mActive</a>;
<a name="l00496"></a><a class="code" href="classOgre_1_1RenderTarget.html#a39c96ae9e871ab7a2c0f139a4391fee8">00496</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1RenderTarget.html#a39c96ae9e871ab7a2c0f139a4391fee8">mAutoUpdate</a>;
<a name="l00497"></a>00497         <span class="comment">// Hardware sRGB gamma conversion done on write?</span>
<a name="l00498"></a><a class="code" href="classOgre_1_1RenderTarget.html#a211bf7a9b86185a4055c73795bb106db">00498</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1RenderTarget.html#a211bf7a9b86185a4055c73795bb106db">mHwGamma</a>;
<a name="l00499"></a>00499         <span class="comment">// FSAA performed?</span>
<a name="l00500"></a><a class="code" href="classOgre_1_1RenderTarget.html#aa6f19609cc8e96488de3a40368f90aeb">00500</a>         <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> <a class="code" href="classOgre_1_1RenderTarget.html#aa6f19609cc8e96488de3a40368f90aeb">mFSAA</a>;
<a name="l00501"></a><a class="code" href="classOgre_1_1RenderTarget.html#a453ef58f7b7efd8bb7b8efb1e0204084">00501</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1RenderTarget.html#a453ef58f7b7efd8bb7b8efb1e0204084">mFSAAHint</a>;
<a name="l00502"></a>00502 
<a name="l00503"></a>00503         <span class="keywordtype">void</span> updateStats(<span class="keywordtype">void</span>);
<a name="l00504"></a>00504 
<a name="l00505"></a><a class="code" href="classOgre_1_1RenderTarget.html#af7532a4774cb67a30de57994c0d58726">00505</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;int, Viewport*&gt;::type</a> <a class="code" href="classOgre_1_1RenderTarget.html#af7532a4774cb67a30de57994c0d58726">ViewportList</a>;
<a name="l00507"></a><a class="code" href="classOgre_1_1RenderTarget.html#a9dbeb5ce1b207cf5bf446e0d69d1b98c">00507</a>         <a class="code" href="classOgre_1_1RenderTarget.html#af7532a4774cb67a30de57994c0d58726">ViewportList</a> <a class="code" href="classOgre_1_1RenderTarget.html#a9dbeb5ce1b207cf5bf446e0d69d1b98c" title="List of viewports, map on Z-order.">mViewportList</a>;
<a name="l00508"></a>00508 
<a name="l00509"></a><a class="code" href="classOgre_1_1RenderTarget.html#a40e3741b510931d186a90935c45dc301">00509</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;RenderTargetListener*&gt;::type</a> <a class="code" href="classOgre_1_1RenderTarget.html#a40e3741b510931d186a90935c45dc301">RenderTargetListenerList</a>;
<a name="l00510"></a><a class="code" href="classOgre_1_1RenderTarget.html#adb18b049cb9528a1605ec4a52ecf832c">00510</a>         <a class="code" href="classOgre_1_1RenderTarget.html#a40e3741b510931d186a90935c45dc301">RenderTargetListenerList</a> <a class="code" href="classOgre_1_1RenderTarget.html#adb18b049cb9528a1605ec4a52ecf832c">mListeners</a>;
<a name="l00511"></a>00511     
<a name="l00512"></a>00512 
<a name="l00514"></a>00514         <span class="keyword">virtual</span> <span class="keywordtype">void</span> firePreUpdate(<span class="keywordtype">void</span>);
<a name="l00516"></a>00516         <span class="keyword">virtual</span> <span class="keywordtype">void</span> firePostUpdate(<span class="keywordtype">void</span>);
<a name="l00518"></a>00518         <span class="keyword">virtual</span> <span class="keywordtype">void</span> fireViewportPreUpdate(<a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a>* vp);
<a name="l00520"></a>00520         <span class="keyword">virtual</span> <span class="keywordtype">void</span> fireViewportPostUpdate(<a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a>* vp);
<a name="l00522"></a>00522         <span class="keyword">virtual</span> <span class="keywordtype">void</span> fireViewportAdded(<a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a>* vp);
<a name="l00524"></a>00524         <span class="keyword">virtual</span> <span class="keywordtype">void</span> fireViewportRemoved(<a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a>* vp);
<a name="l00525"></a>00525         
<a name="l00527"></a>00527         <span class="keyword">virtual</span> <span class="keywordtype">void</span> updateImpl();
<a name="l00528"></a>00528     };
<a name="l00532"></a>00532 } <span class="comment">// Namespace</span>
<a name="l00533"></a>00533 
<a name="l00534"></a>00534 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
